from __future__ import division
import matplotlib
matplotlib.use('Agg')
import matplotlib.cm as cm
import matplotlib.colors as cl
import matplotlib.pyplot as plt
import pickle
import pprint
from collections import defaultdict
import numpy as np
import random
import math
import csv
from collections import Counter
import ray, logging
import time

import time
#import users types dictionary
pkl_file = open('tipo4SP30.pkl','rb')
tipo = pickle.load(pkl_file)
pkl_file.close()
#import sir hotspots dictionary
pkl_file = open('hotssir.pkl','rb')
data1 = pickle.load(pkl_file)
hots=data1
pkl_file.close()
#import users destinations dict
pkl_file = open('sem30dest.pkl','rb')
sem = pickle.load(pkl_file)
pkl_file.close()

from scipy.stats import gamma #define gamma dist for infectious periods
shape=(10.6);scale=1; #params a and b of the gamma distribution, shape a and scale b


## USE THIS FOR THE SIR

totsim=0
totexp=0
totsimw=0
totexpw=0

R0=2.7 #set reproductive number

import random

# HERE IT STARTS
infsim=[]
expsim=[]
infsimw=[]
expsimw=[]

mu0=1/(24*4*10.6) #1 over number of 15mins time cells in 10 days, it takes 10 days to recover on av. #Riley et al, SI section6

cr=34.6 #contact rate (unique contacts per time slot)
tau=96/8 #(fraction of day spent in the airport)^(-1)

beta0=R0*mu0*tau/cr
#I have cells of 15mins, I have to scale the probabilities

beta=1-np.exp(-beta0) #deltat would be 1, which is a 15mins time cells

mu=1-np.exp(-mu0)

mem=4294967296 #set memory needed for simulation

ray.init(num_cpus=3,memory=mem,object_store_memory=mem) #parallelizing
@ray.remote
def simul():

    ip={};count_ip={}  #assign Gamma distributed infectious periods to each agent
    for us in tipo:
        ip[str(us)]=gamma.rvs(shape, scale=scale)*24*4 #extract infectious period from gamma and translate it to time slots units
        count_ip[str(us)]=0


    infected_cells1=[] #list of infected cells for the 1st,2nd,3rd day
    infected_cells2=[]
    infected_cells3=[]

    tend=96
    tstart=54
    t=tstart
    t+=1

    edges=dict()
    start_time = time.clock()
    
    timecell=t
    with open('1day/2network_t'+str(t)+'.dat','rb') as dfile:  #read temporal contact network at time t
        spamreader = csv.reader(dfile, delimiter=' ', quotechar='|')
        for row in spamreader:
            
            cell=row[2].strip('[').strip(']').strip("'")
            cond=edges.get(row[0],'e')
            if cond=='e':
                edges[row[0]]={}
            
            cond3=edges[row[0]].get(row[1],'e')
            if cond3=='e':
                edges[row[0]][row[1]]=[]
            
            edges[row[0]][row[1]].append(cell)
            
            con2=edges.get(row[1],'e')
            if con2=='e':
                edges[row[1]]={}
            
            cond4=edges[row[1]].get(row[0],'e')
            if cond4=='e':
                edges[row[1]][row[0]]=[]
                
            edges[row[1]][row[0]].append(cell)
            

    cont=0
    links=edges.keys()
    
    seedtype='d'
    while seedtype!='a':  #set a random seed among arrivals
        random.shuffle(links)
        seed=links[0]
        seedtype=tipo[int(seed)]

    
    infected_nodes=[] #infected users
    infected_nodes.append(seed)
    
    finf=set() #total inf at the end of each simulation
    finfw=set() #total inf workers at the end of each simulation
    finf.add(seed)

    r_nodes=[]

    disease_status=defaultdict()
    disease_status[seed]=1 #1 infected, 0 susceptible, -1 recovered

    t+=1
    #start time HERE
    dove=dict() #dict of areas where contagions occur
    dove['2A']=0 #t2A
    dove['2B']=0 #t2B
    dove['3']=0 #t3
    dove['4']=0 #t4
    dove['5A']=0 #t5A
    dove['5BC']=0 #t5BC
    dove['6']=0 #arrival
    dove['7']=0 #worker
    contagicum=0 #total contagions occurred
    lcontagicum=[] #list of cumulative contagions in time
    lcontagi=[] #list of new contagions in time
    days=7
    day=1
    while day<=days:
        if all([len(infected_nodes)==0]): #exit in case there are no more infected agents
            break
        while t<tend:
            if all([len(infected_nodes)==0]):
                break
            
            timecell=t
            edges=dict()
            contagi=0 #total contagions occurring at time t
            with open('1day/2network_t'+str(t)+'.dat','rb') as dfile:
                spamreader = csv.reader(dfile, delimiter=' ', quotechar='|')
                for row in spamreader:
                
                    cell=row[2].strip('[').strip(']').strip("'")
                    cond=edges.get(row[0],'e')
                    if cond=='e':
                        edges[row[0]]={}
                    
                    cond3=edges[row[0]].get(row[1],'e')
                    if cond3=='e':
                        edges[row[0]][row[1]]=[]
                    
                    edges[row[0]][row[1]].append(cell)
                    
                    con2=edges.get(row[1],'e')
                    if con2=='e':
                        edges[row[1]]={}
                    
                    cond4=edges[row[1]].get(row[0],'e')
                    if cond4=='e':
                        edges[row[1]][row[0]]=[]
                        
                    edges[row[1]][row[0]].append(cell)        

            #transmission
            for i in infected_nodes: #just look at the contacts of the infected ones
                condd=edges.get(i,'e') #i infect only in the airport
                if condd!='e':  #could be that somebody left the airport already
                    source=tipo[int(i)] #get type of the agent i
                    
                    for j in edges[i].keys():
                        cond6=disease_status.get(j,'e')
                        if cond6=='e': #if j not in disease_status, it is susceptible
                            target=tipo[int(j)] #get type of agent j
                            if any([all([source=='a',target=='d']),all([source=='d',target=='a'])]):
                                #arrivals and departures are assumed not to cross each other here
                                continue #skip to next contact of agent i
                            else:
                                for k in range(len(edges[i][j])): #for every time i and j meet at time t
                                    
                                    cell=int(edges[i][j][k])
                                    p=np.random.random()
                                    
                                    if cell in hots: #if this cells belongs to immunized areas
                                        thresh=beta*0.05/len(edges[i][j]) #immunization reducing probability of infection
                                    else:
                                        thresh=beta/len(edges[i][j])
                                    
                                    if p<thresh: #trigger infection
                                        
                                        #add cell to list of infectious cells
                                        if day==1:
                                            infected_cells1.append(int(edges[i][j][k]))
                                        if day==2:
                                            infected_cells2.append(int(edges[i][j][k]))
                                        if day==3:
                                            infected_cells3.append(int(edges[i][j][k]))
                                        
                                        disease_status[j]=1 #update status of agent j to infected
                                        finf.add(j)

                                        contagi+=1
                                        contagicum+=1
                                        #update dict of infected agents by category
                                        if tipo[int(j)]=='w': #if worker
                                            finfw.add(j)
                                            dove['7']+=1
                                        elif tipo[int(j)]=='a': #if arrival
                                            dove['6']+=1
                                        else:
                                            cont=sem.get(int(j),'e') #other travelers categories are endoded in the imported dict
                                            if cont!='e':
                                                dove[sem[int(j)]]+=1
                                        
                                        break #if contagion occurs, further interactions at time t between i and j are not needed

            #recovery
            for k in infected_nodes:
                count_ip[k]+=1 #counter of waiting time for each infected agent, to implement the gamma dist infectious period
                if count_ip[k]>ip[k]: #if enough time passed for agent k
                    disease_status[k]=-1 #recover
                    finf.remove(k)
                    if tipo[int(k)]=='w':
                        finfw.remove(k)

            #update of disease status and infected nodes list
            infected_nodes=[]
            r_nodes=[]

            for n in disease_status.keys():
                if tipo[int(n)]!='w': #if it is a traveler i have to check if it is inside, cause if infected and exits, i can close the simulation
                    condd2=edges.get(n,'e')
                    if condd2!='e':  #if still in the airport
                        if disease_status[n]==1:
                            infected_nodes.append(n)
                        elif disease_status[n]==-1:
                            r_nodes.append(n)
                if tipo[int(n)]=='w':
                    #if it worker it can go out and come back next day
                    if disease_status[n]==1:
                        infected_nodes.append(n)
                    elif disease_status[n]==-1:
                        r_nodes.append(n)
                

            t+=1
	    lcontagi.append(contagi) #save new contagions occurring at time t in the list of new contagions in time
	    lcontagicum.append(contagicum) #same with cumulative contagions
        
        day+=1
        t=0
        infected_nodes=[]
        r_nodes=[]
        
        #reset infected nodes who are not workers, for the next day simulation
        for n in disease_status.keys(): #at the end of each day, each traveler becomes susceptible again, assuming they are different individuals
            
            if tipo[int(n)]=='w':
                if disease_status[n]==1:
                    infected_nodes.append(n) #i want only workers to survive as infected to the next day simulation
                elif disease_status[n]==-1:
                    r_nodes.append(n)
        
        disease_status=defaultdict() #empty disease_status dict
        #now disease status only contains workers
        for n in infected_nodes:
            disease_status[n]=1 #infected
        for n in r_nodes:
            disease_status[n]=-1 #recovered
    
    print len(finf),len(finfw) #total infections at the end of the week, total infected workers at the end of the week
    print dove['2A'],dove['2B'],dove['3'],dove['4'],dove['5A'],dove['5BC'],dove['6'],dove['7']  #total infections at the end of the week, stratified by category
    print lcontagicum #cumulative infections in time
    print lcontagi #new infections in time

    print infected_cells1 #list of cells with contagions at day 1, 2 or 3
    print infected_cells2
    print infected_cells3

# Start tasks in the background.
simulations = 5 #repeat 5 times
res = ray.get([simul.remote() for c in range(simulations)])

ray.shutdown()
